 import "Turbine.UI"; 
 import "Turbine.UI.Extensions"; 
 import "Turbine.UI.Lotro"; 

 import "Homeopatix.PetStable.Globals"
 import "Homeopatix.PetStable.MinimizedIcon"
 import "Homeopatix.PetStable.VindarPatch"
 import "Homeopatix.PetStable.Commands"
 import "Homeopatix.PetStable.LoadAndSave"
 import "Homeopatix.PetStable.MainWindow"
 import "Homeopatix.PetStable.FCT"

Turbine.Shell.WriteLine("<rgb=#CC56DA>Pet Stable</rgb> <rgb=#DDDDDD>".. plugin:GetVersion() .." par Homeo</rgb>")

CreateLocalizationInfo();
LoadSettings();

------------------------------------------------------------------------------------------
-- create the main window
------------------------------------------------------------------------------------------
CreateMainWindow();

------------------------------------------------------------------------------------------
-- setting the shortcuts
------------------------------------------------------------------------------------------
SetTheShortCuts();

------------------------------------------------------------------------------------------
-- setting the shortcuts for drag and drop
------------------------------------------------------------------------------------------
DragAndDrop();

------------------------------------------------------------------------------------------
-- event handling
------------------------------------------------------------------------------------------
MouseCLickHandler();

------------------------------------------------------------------------------------------
-- delete the shortcut with mouse wheel
------------------------------------------------------------------------------------------
DeleteShortCuts();

------------------------------------------------------------------------------------------
-- Closing window handler
------------------------------------------------------------------------------------------
ClosingWindow();

------------------------------------------------------------------------------------------
-- handle minimizeIcon
------------------------------------------------------------------------------------------
MainMinimizedIcon = MinimizedIcon(Images.MinimizedIcon, 32, 32, PetStableWindow:SetVisible(false));
settings.isWindowVisible = false;
SaveSettings(4);
MainMinimizedIcon:SetPosition(settings.minimizeX, settings.minimizeY);
MainMinimizedIcon:SetZOrder(0);
MainMinimizedIcon.PositionChanged = function()
	settings.minimizeX = MainMinimizedIcon:GetLeft();
	settings.minimizeY = MainMinimizedIcon:GetTop();
	SaveSettings(2);
end

------------------------------------------------------------------------------------------
-- event handler
------------------------------------------------------------------------------------------
PetStableWindow.KeyDown=function(sender, args)
	if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
		PetStableWindow:SetVisible(false);
		settings.isWindowVisible = false;
		SaveSettings(4);
	end
	
	-- https://www.lotro.com/forums/showthread.php?493466-How-to-hide-a-window-on-F12&p=6581962#post6581962
	if ( args.Action == 268435635 ) then
		hudVisible=not hudVisible;
		if hudVisible then
			PetStableWindow:SetVisible(false);
			MainMinimizedIcon:SetVisible(false);
		else
			PetStableWindow:SetVisible(settings.isWindowVisible);
			MainMinimizedIcon:SetVisible(true);
		end
	end
end

------------------------------------------------------------------------------------------
-- if the position changes, save the new window location
------------------------------------------------------------------------------------------
	PetStableWindow.PositionChanged = function( sender, args )
    	local x,y = PetStableWindow:GetPosition();
    	settings.positionX = x;
    	settings.positionY = y;
		SaveSettings(1);
	end